import UIKit
import Flutter
import ContentsquareModule
import background_locator

@UIApplicationMain
@objc class AppDelegate: FlutterAppDelegate {
    override func application(_ application: UIApplication, didFinishLaunchingWithOptions launchOptions:[UIApplication.LaunchOptionsKey: Any]? ) -> Bool {
        GeneratedPluginRegistrant.register(with: self)
        BackgroundLocatorPlugin.setPluginRegistrantCallback { registry in
            if (!registry.hasPlugin("BackgroundLocatorPlugin")) {
                GeneratedPluginRegistrant.register(with: registry)
            }
        }
        return super.application(application, didFinishLaunchingWithOptions: launchOptions)
    }

    override func application(_ app: UIApplication, open url: URL, options: [UIApplication.OpenURLOptionsKey : Any] = [:]) -> Bool {
        Contentsquare.handle(url: url)
        return super.application(app, open: url, options: options)
    }
}
