import 'package:auto_route/auto_route.dart';
import 'package:flutter/widgets.dart';

import '../src/scaffold.dart';
import '../src/screens/api_tests/api_tests_screen.dart';
import '../src/screens/api_tests/widgets/privacy/privacy_screen.dart';
import '../src/screens/cases/cases_router_wrapper.dart';
import '../src/screens/cases/cases_screen.dart';
import '../src/screens/cases/jumping_screen.dart';
import '../src/screens/home/home_screen.dart';
import '../src/screens/info/info_screen.dart';

part 'app_router.gr.dart';

@MaterialAutoRouter(
  replaceInRouteName: 'Screen,Route',
  routes: <AutoRoute>[
    AutoRoute(
      page: MyScaffold,
      name: 'MyScaffoldRoute',
      initial: true,
      children: [
        AutoRoute(page: HomeScreen),
        AutoRoute(
          page: EmptyRouterPage,
          name: 'APITestsRouter',
          children: [
            AutoRoute(page: APITestsScreen, initial: true),
            AutoRoute(page: PrivacyScreen),
          ],
        ),
        AutoRoute(
          page: CasesRouterWrapper,
          name: 'CasesRouter',
          children: [
            AutoRoute(page: CasesScreen, initial: true),
            AutoRoute(page: JumpingScreen),
          ],
        ),
        AutoRoute(page: InfoScreen),
      ],
    ),
  ],
)

// extend the generated private router
class AppRouter extends _$AppRouter {}
