import 'package:auto_route/auto_route.dart';
import 'package:flutter/material.dart';

import '../routes/app_router.dart';
import 'widgets/contentsquare_screen_monitor.dart';

class MyScaffold extends StatelessWidget {
  static const _routes = [
    HomeRoute(),
    APITestsRouter(),
    CasesRouter(),
    InfoRoute(),
  ];

  @override
  Widget build(context) {
    return ContentsquareScreenMonitor(
      child: AutoTabsRouter(
        lazyLoad: false,
        routes: _routes,
        builder: (context, child, animation) {
          final tabsRouter = AutoTabsRouter.of(context);
          return Scaffold(
            body: FadeTransition(
              opacity: animation,
              child: child,
            ),
            bottomNavigationBar: BottomNavigationBar(
              selectedItemColor: Colors.black,
              unselectedItemColor: Colors.grey,
              showUnselectedLabels: true,
              currentIndex: tabsRouter.activeIndex,
              onTap: (index) {
                ContentsquareScreenMonitor.sendScreenView(
                  context,
                  screenName: '${_routes[index].runtimeType}',
                );
                tabsRouter.setActiveIndex(index);
              },
              items: [
                BottomNavigationBarItem(icon: Icon(Icons.home), label: 'Home'),
                BottomNavigationBarItem(
                    icon: Icon(Icons.code), label: 'API tests'),
                BottomNavigationBarItem(icon: Icon(Icons.list), label: 'Cases'),
                BottomNavigationBarItem(icon: Icon(Icons.info), label: 'Info'),
              ],
            ),
          );
        },
      ),
    );
  }
}
