import 'package:contentsquare/contentsquare.dart';
import 'package:flutter/material.dart';
import 'package:flutter/services.dart';

class SendDynamicVariableWidget extends StatefulWidget {
  @override
  State<SendDynamicVariableWidget> createState() =>
      _SendDynamicVariableWidgetState();
}

class _SendDynamicVariableWidgetState extends State<SendDynamicVariableWidget> {
  var intValue = 0;
  var stringValue = 'My value';
  late final _controller = TextEditingController(text: stringValue);

  Future<void> sendDynamicVar(
    BuildContext context, {
    String? stringValue,
    int? intValue,
  }) async {
    try {
      await Contentsquare().sendDynamicVar(
        'my key 1',
        stringValue: stringValue,
        intValue: intValue,
      );
    } on PlatformException catch (e) {
      if (e.message != null) {
        ScaffoldMessenger.of(context)
            .showSnackBar(SnackBar(content: Text(e.message!)));
      }
    }
  }

  @override
  Widget build(BuildContext context) {
    return Padding(
      padding: const EdgeInsets.symmetric(horizontal: 20.0),
      child: Column(
        mainAxisSize: MainAxisSize.min,
        crossAxisAlignment: CrossAxisAlignment.start,
        children: [
          Row(
            children: [
              OutlinedButton(
                onPressed: () => sendDynamicVar(context, intValue: intValue),
                child: Text('Send the number'),
              ),
              SizedBox(width: 10),
              IconButton(
                onPressed: () => setState(() => --intValue),
                icon: Icon(Icons.remove),
              ),
              Text('$intValue'),
              IconButton(
                onPressed: () => setState(() => ++intValue),
                icon: Icon(Icons.add),
              ),
            ],
          ),
          SizedBox(height: 20),
          Row(
            children: [
              OutlinedButton(
                onPressed: () =>
                    sendDynamicVar(context, stringValue: stringValue),
                child: Text('Send the string'),
              ),
              SizedBox(width: 40),
              Flexible(
                child: TextField(
                  controller: _controller,
                  onChanged: (value) => setState(() => stringValue = value),
                ),
              ),
            ],
          )
        ],
      ),
    );
  }
}
