import 'package:contentsquare/contentsquare.dart';
import 'package:flutter/material.dart';
import 'package:flutter/services.dart';

class SendTransactionWidget extends StatelessWidget {
  Future<void> sendTransaction(
    BuildContext context, [
    String? transactionId,
  ]) async {
    try {
      await Contentsquare().sendTransaction(430, 'EUR', transactionId);
    } on PlatformException catch (e) {
      if (e.message != null) {
        ScaffoldMessenger.of(context)
            .showSnackBar(SnackBar(content: Text(e.message!)));
      }
    }
  }

  @override
  Widget build(BuildContext context) {
    return Row(mainAxisAlignment: MainAxisAlignment.spaceEvenly, children: [
      OutlinedButton(
        onPressed: () => sendTransaction(context, 'id'),
        child: Text('Send a transaction'),
      ),
      OutlinedButton(
        onPressed: () => sendTransaction(
          context,
        ),
        child: Text('Send a transaction without id'),
      )
    ]);
  }
}
