/// This file is inspired from gesture_x_detector.dart from the [gesture_x_detector](https://github.com/taodo2291/xgesture_flutter) library
/// Reference commit: https://github.com/taodo2291/xgesture_flutter/tree/f57721bed8194021f36b3e454ef7b828bf259c53

import 'dart:async';

import 'package:flutter/gestures.dart';
import 'package:flutter/widgets.dart';


class a66 {
  
  final Offset a58;

  
  final Offset a57;

  
  final Offset a56;

  
  a66._a88(_a69 a216)
      : a58 = a216.a41,
        a57 = a216.a40 - a216.a41,
        a56 =
            a216.a39.getVelocityEstimate()?.pixelsPerSecond ??
                Offset.zero;
}

/// Signature for listening to tap events.
typedef TapEventListener = void Function(PointerEvent event);

/// Signature for listening to move events.
typedef MoveEventListener = void Function(a66 event);


class a67 extends StatefulWidget {
  
  const a67({
    Key? a217,
    required this.a55,
    this.a54,
    this.a53,
    this.a52,
    this.a51,
    this.a50,
    this.a49,
    this.a47 = kLongPressTimeout,
    this.a48 = kTouchSlop,
    this.a46 = true,
  }) : super(key: a217);

  
  final Widget a55;

  
  final TapEventListener? a54;

  
  final TapEventListener? a53;

  
  final Function()? a52;

  
  final MoveEventListener? a51;

  
  final MoveEventListener? a50;

  
  final MoveEventListener? a49;

  
  final double a48;

  
  final Duration a47;

  
  final bool a46;

  @override
  _a70 createState() => _a70();
}

enum _a68 {
  a45,
  a44,
  a43,
  a42,
}

class _a69 {
  late Offset a41;
  late Offset a40;
  late VelocityTracker a39;

  Offset get a3 => a40 - a41;

  _a69.a89(PointerEvent a218) {
    a41 = a218.localPosition;
    a40 = a41;
    a39 = VelocityTracker.withKind(a218.kind)
      ..addPosition(a218.timeStamp, a218.position);
  }
}

class _a70 extends State<a67> {
  final Map<int, _a69> _a130 = <int, _a69>{};
  _a68 a38 = _a68.a42;
  Timer? a37;
  Offset a36 = Offset.zero;

  @override
  Widget build(BuildContext context) {
    return Listener(
      behavior: HitTestBehavior.translucent,
      child: widget.a55,
      onPointerDown: a15,
      onPointerUp: a12,
      onPointerMove: a14,
      onPointerCancel: a11,
    );
  }

  @override
  void dispose() {
    _a91();
    _a130.clear();
    super.dispose();
  }

  void _a90(int a219) {
    _a130.remove(a219);
  }

  void a15(PointerDownEvent a208) {
    _a130[a208.pointer] = _a69.a89(a208);

    if (a2 == 1) {
      a38 = _a68.a45;
      a10(a208);
    } else {
      a38 = _a68.a42;
    }
  }

  void a14(PointerMoveEvent a207) {
    final a131 = _a130[a207.pointer];

    if (a131 == null) return;

    a131.a40 = a207.localPosition;

    if (!a9(a131)) {
      _a91();
    }

    switch (a38) {
      case _a68.a43:
        if (widget.a46) {
          a131.a41 = a131.a40;
        } else {
          a13(a131, a207);
        }
        break;
      case _a68.a45:
        a13(a131, a207);
        break;
      case _a68.a44:
        a131.a39.addPosition(a207.timeStamp, a207.position);
        widget.a50?.call(a66._a88(a131));
        break;

      default:
        a131.a41 = a131.a40;
        break;
    }
  }

  void a13(_a69 a205, PointerMoveEvent a206) {
    a205.a40 = a206.localPosition;
    if (!a9(a205)) {
      a38 = _a68.a44;
      widget.a51?.call(a66._a88(a205));
    }
  }

  void a12(PointerUpEvent a204) {
    final a132 = _a130[a204.pointer];
    if (a132 == null) return;

    a132.a40 = a204.position;
    if (a38 == _a68.a45) {
      a8(a204.copyWith(position: a132.a41));
    } else if (a38 == _a68.a44) {
      a38 = _a68.a42;
      a132.a39.addPosition(a204.timeStamp, a204.position);

      widget.a49?.call(a66._a88(a132));
    } else if (a38 == _a68.a43) {
      widget.a52?.call();
      a38 = _a68.a42;
    } else {
      a38 = _a68.a42;
    }

    a36 = a204.localPosition;
    _a90(a204.pointer);
  }

  void a11(PointerCancelEvent a203) =>
      _a90(a203.pointer);

  void a10(PointerEvent a202) {
    if (widget.a53 != null) {
      a37?.cancel();
      a37 = Timer(widget.a47, () {
        if (a2 == 1 && _a130.entries.first.key == a202.pointer) {
          a38 = _a68.a43;
          widget.a53!(a202);
          _a91();
        }
      });
    }
  }

  bool a9(_a69 a201) {
    return a201.a3.distance.abs() <= widget.a48;
  }

  void _a91() {
    a37?.cancel();
    a37 = null;
  }

  void a8(PointerEvent a200) {
    widget.a54?.call(a200);
  }

  get a2 => _a130.length;
}
