import 'dart:io';

/// Return the version of flutter that was used to run main.dart
///
/// Important: This function relies on FVM. If you run your tests without FVM,
/// it will fail
//
// Note: A better method would be to use
// `Process.runSync('flutter', ['--version', '--machine']);`
// However `Process.runSync` hangs randomly on some Flutter version (See
// https://github.com/flutter/flutter/issues/95805 for the associated github
// issue). This makes it impossible to use since the goal of this method is to
// return *any* current Flutter version.
String getFlutterVersion() {
  // The path to the Flutter SDK. If FVM is used, the path should look like:
  //   /Users/lulupointu/fvm/versions/2.5.3
  final flutterRoot = Platform.environment['FLUTTER_ROOT'];
  if (flutterRoot == null) {
    throw 'Could not get the FLUTTER_ROOT environment variable.\nMake sure you use FVM to start the tests';
  }
  final flutterVersion = Uri.parse(flutterRoot).pathSegments.last;
  final versionValidatorRegexp = RegExp(r'^\d+\.\d+\.\d+$');
  final isFlutterVersionValid = versionValidatorRegexp.hasMatch(flutterVersion);
  if (!isFlutterVersionValid) {
    throw 'Could not get the FLUTTER_ROOT environment variable.\nFLUTTER_ROOT: $flutterRoot, parsedFlutterVersion: $flutterVersion.\nMake sure you use FVM to start the tests';
  }

  return flutterVersion;
}
