import 'dart:collection';

import 'package:contentsquare/src/modules/screengraph/unmodifiable_list_view_extension.dart';
import 'package:flutter/foundation.dart';
import 'package:flutter_test/flutter_test.dart';

main() {
  group(
    'removeDuplicatesAndInclusions',
    () {
      testWidgets(
        'Should remove duplicates',
        (WidgetTester tester) async {
          final listWithDuplicates = UnmodifiableListView(
            ['a', 'b', 'a', 'd', 'f', 'f'],
          );
          final listWithoutDuplicates =
              UnmodifiableListView(['a', 'b', 'd', 'f']);

          final result = listWithDuplicates.removeDuplicatesAndInclusions();

          expect(listEquals(result, listWithoutDuplicates), true);
        },
      );

      testWidgets(
        'Should remove inclusions',
        (WidgetTester tester) async {
          final listWithInclusions = UnmodifiableListView(
            ['a>b>c', 'z>b>c', 'a>b', 'a', 'b', 'c'],
          );
          final listWithoutInclusions = UnmodifiableListView(
            ['a>b>c', 'z>b>c', 'b', 'c'],
          );

          final result = listWithInclusions.removeDuplicatesAndInclusions();

          expect(listEquals(result, listWithoutInclusions), true);
        },
      );
    },
  );
}
